@ECHO OFF

:TOP
CLS
@ECHO 
@ECHO GeneRally Drivers, Options, Saved Seasons, and Tracks Backup Utility v7.2
@ECHO 
@ECHO [B]ackup
@ECHO [R]estore
@ECHO [T]est GeneRally Backup Archive
@ECHO [D]elete GeneRally Backup Archive
@ECHO [E]dit GeneRally Backup Archive Files List
@ECHO Delete [A]utosave.gam Saved Season
@ECHO [L]ist Cars, Drivers, Options, Saved Seasons, Sound Folders, and Tracks
@ECHO [V]iew Shot0000.bmp Screenshot
@ECHO Delete All [S]creenshots
@ECHO [P]lay GeneRally
@ECHO [G]eneRally Track Editor
@ECHO Sort [C]ar Files
@ECHO Sort Sound [F]olders
@ECHO Edit GR.[I]NI Advanced Game Options File
@ECHO GeneRally [O]ptionToy
@ECHO [J]uan's "GeneRally Options" Utility
@ECHO [M]etric Calculator
@ECHO [W]indows Explorer
@ECHO [H]elp
@ECHO [Q]uit
@ECHO.
CHOICE /C:BRTDEALVSPGCFIOJMWHQ
IF ERRORLEVEL 20 GOTO QUIT
IF ERRORLEVEL 19 GOTO HELP
IF ERRORLEVEL 18 GOTO EXPLORER
IF ERRORLEVEL 17 GOTO METRICAL
IF ERRORLEVEL 16 GOTO OPTSUTILITY
IF ERRORLEVEL 15 GOTO OPTIONTOY
IF ERRORLEVEL 14 GOTO EDITINI
IF ERRORLEVEL 13 GOTO SORTSOUNDS
IF ERRORLEVEL 12 GOTO SORTCARS
IF ERRORLEVEL 11 GOTO TRACKEDITOR
IF ERRORLEVEL 10 GOTO GENERALLY
IF ERRORLEVEL 9 GOTO DELETESHOTS
IF ERRORLEVEL 8 GOTO VIEWSHOT
IF ERRORLEVEL 7 GOTO FILESLIST
IF ERRORLEVEL 6 GOTO AUTOSAVE
IF ERRORLEVEL 5 GOTO EDITLIST
IF ERRORLEVEL 4 GOTO DELETEARCHIVE
IF ERRORLEVEL 3 GOTO TESTARCHIVE
IF ERRORLEVEL 2 GOTO RESTORE
IF ERRORLEVEL 1 GOTO BACKUP

:BACKUP
CLS
@ECHO 
@ECHO Backup GeneRally Files
@ECHO 
@ECHO.
@ECHO [A]ll Drivers, Options, Saved Seasons, and Tracks
@ECHO.
@ECHO [D]rivers
@ECHO [O]ptions
@ECHO [S]aved Seasons
@ECHO [T]racks
@ECHO.
@ECHO [C]ancel
@ECHO.
CHOICE /C:ADOSTC
IF ERRORLEVEL 6 GOTO TOP
IF ERRORLEVEL 5 GOTO TRACKSBACKUP
IF ERRORLEVEL 4 GOTO SEASONSBACKUP
IF ERRORLEVEL 3 GOTO OPTIONSBACKUP
IF ERRORLEVEL 2 GOTO DRIVERSBACKUP
IF ERRORLEVEL 1 GOTO ALLBACKUP

:ALLBACKUP
@ECHO.
@ECHO Press Ctrl+C to abort or
PAUSE
PKZIP -! -es -o -P -r -xSaves\Autosave.gam GRBACKUP.ZIP @GRBACKUP.LST
@ECHO.
@ECHO All drivers, options, saved seasons, and tracks backup complete!
@ECHO.
PAUSE
GOTO TOP

:DRIVERSBACKUP
@ECHO.
@ECHO Press Ctrl+C to abort or
PAUSE
PKZIP -! -es -o -P -r GRBACKUP.ZIP Drivers\*.drv
@ECHO.
@ECHO Drivers backup complete!
@ECHO.
PAUSE
GOTO TOP

:OPTIONSBACKUP
@ECHO.
@ECHO Press Ctrl+C to abort or
PAUSE
PKZIP -! -es -o GRBACKUP.ZIP GR.ini Options.opt Options.set
@ECHO.
@ECHO Options backup complete!
@ECHO.
PAUSE
GOTO TOP

:SEASONSBACKUP
@ECHO.
@ECHO Press Ctrl+C to abort or
PAUSE
PKZIP -! -es -o -P -r -xSaves\Autosave.gam GRBACKUP.ZIP Saves\*.gam
@ECHO.
@ECHO Saved seasons backup complete!
@ECHO.
PAUSE
GOTO TOP

:TRACKSBACKUP
@ECHO.
@ECHO Press Ctrl+C to abort or
PAUSE
PKZIP -! -es -o -P -r GRBACKUP.ZIP Tracks\*.trk
@ECHO.
@ECHO Tracks backup complete!
@ECHO.
PAUSE
GOTO TOP

:RESTORE
IF NOT EXIST GRBACKUP.ZIP GOTO NOARCHIVE
CLS
@ECHO 
@ECHO Restore GeneRally Files
@ECHO 
@ECHO.
@ECHO [A]ll Drivers, Options, Saved Seasons, and Tracks
@ECHO.
@ECHO [D]rivers
@ECHO [O]ptions
@ECHO [S]aved Seasons
@ECHO [T]racks
@ECHO.
@ECHO [C]ancel
@ECHO.
CHOICE /C:ADOSTC
IF ERRORLEVEL 6 GOTO TOP
IF ERRORLEVEL 5 GOTO TRACKSRESTORE
IF ERRORLEVEL 4 GOTO SEASONSRESTORE
IF ERRORLEVEL 3 GOTO OPTIONSRESTORE
IF ERRORLEVEL 2 GOTO DRIVERSRESTORE
IF ERRORLEVEL 1 GOTO ALLRESTORE

:ALLRESTORE
@ECHO.
@ECHO Press Ctrl+C to abort or
PAUSE
PKUNZIP GRBACKUP.ZIP -d
@ECHO.
@ECHO All drivers, options, saved seasons, and tracks restored!
@ECHO.
PAUSE
GOTO TOP

:DRIVERSRESTORE
@ECHO.
@ECHO Press Ctrl+C to abort or
PAUSE
PKUNZIP GRBACKUP.ZIP *.drv -d
@ECHO.
@ECHO Drivers restored!
@ECHO.
PAUSE
GOTO TOP

:OPTIONSRESTORE
@ECHO.
@ECHO Press Ctrl+C to abort or
PAUSE
PKUNZIP GRBACKUP.ZIP GR.ini Options.opt Options.set
@ECHO.
@ECHO Options restored!
@ECHO.
PAUSE
GOTO TOP

:SEASONSRESTORE
@ECHO.
@ECHO Press Ctrl+C to abort or
PAUSE
PKUNZIP GRBACKUP.ZIP *.gam -d
@ECHO.
@ECHO Saved seasons restored!
@ECHO.
PAUSE
GOTO TOP

:TRACKSRESTORE
@ECHO.
@ECHO Press Ctrl+C to abort or
PAUSE
PKUNZIP GRBACKUP.ZIP *.trk -d
@ECHO.
@ECHO Tracks restored!
@ECHO.
PAUSE
GOTO TOP

:TESTARCHIVE
IF NOT EXIST GRBACKUP.ZIP GOTO NOARCHIVE
@ECHO.
@ECHO Now testing GRBACKUP.ZIP GeneRally backup archive
PAUSE
PKUNZIP GRBACKUP.ZIP -t
IF ERRORLEVEL 1 GOTO ERROR
IF ERRORLEVEL 0 GOTO OK

:OK
@ECHO.
@ECHO GRBACKUP.ZIP GeneRally backup archive OK!
@ECHO.
PAUSE
GOTO TOP

:ERROR
@ECHO >CON
@ECHO GRBACKUP.ZIP GENERALLY BACKUP ARCHIVE HAD ERRORS!
@ECHO.
PAUSE
GOTO TOP

:DELETEARCHIVE
IF NOT EXIST GRBACKUP.ZIP GOTO NOARCHIVE
@ECHO.
DEL GRBACKUP.ZIP /P
@ECHO.
PAUSE
GOTO TOP

:EDITLIST
EDIT GRBACKUP.LST
@ECHO.
@ECHO If you have made any edits or changes to the GeneRally backup archive files
@ECHO list (GRBACKUP.LST), remember to back up your files again.
@ECHO.
PAUSE
GOTO TOP

:AUTOSAVE
IF NOT EXIST Saves\Autosave.gam GOTO NOAUTOSAVE
@ECHO.
DEL Saves\Autosave.gam /P
@ECHO.
PAUSE
GOTO TOP

:FILESLIST
CLS
@ECHO 
@ECHO List GeneRally Files
@ECHO 
@ECHO.
@ECHO [A]rchive Listing (GRBACKUP.ZIP)
@ECHO.
@ECHO [B]rief Listing (Hard Drive)
@ECHO [F]ull Listing (Hard Drive)
@ECHO [V]erbose Listing (Hard Drive)
@ECHO.
@ECHO [C]ancel
@ECHO.
CHOICE /C:ABFVC
IF ERRORLEVEL 5 GOTO TOP
IF ERRORLEVEL 4 GOTO VERBOSELIST
IF ERRORLEVEL 3 GOTO FULLLIST
IF ERRORLEVEL 2 GOTO BRIEFLIST
IF ERRORLEVEL 1 GOTO ARCHIVELIST

:ARCHIVELIST
IF NOT EXIST GRBACKUP.ZIP GOTO NOARCHIVE
@ECHO >>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Drivers>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
PKUNZIP GRBACKUP.ZIP *.drv -vbn>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Options>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
PKUNZIP GRBACKUP.ZIP GR.ini Options.opt Options.set -vbn>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Saved Seasons>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
PKUNZIP GRBACKUP.ZIP *.gam -vbn>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Tracks>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
PKUNZIP GRBACKUP.ZIP *.trk -vbn>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
EDIT FILESLIST.TXT
DEL FILESLIST.TXT /P
@ECHO.
PAUSE
GOTO TOP

:BRIEFLIST
@ECHO >>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Cars>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/B/ON Cars\*.car>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Drivers>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/B/ON Drivers\*.drv>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Options>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/B GR.ini>>FILESLIST.TXT
DIR/B Options.opt>>FILESLIST.TXT
DIR/B Options.set>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Saved Seasons>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/B/ON Saves\*.gam>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Sound Folders>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/AD/B/ON Sounds>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Tracks>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/B/ON/S Tracks\*.trk>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
EDIT FILESLIST.TXT
DEL FILESLIST.TXT /P
@ECHO.
PAUSE
GOTO TOP

:FULLLIST
@ECHO >>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Cars>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/ON Cars\*.car>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Drivers>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/ON Drivers\*.drv>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Options>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR GR.ini>>FILESLIST.TXT
DIR Options.opt>>FILESLIST.TXT
DIR Options.set>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Saved Seasons>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/ON Saves\*.gam>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Sound Folders>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/AD/ON Sounds>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Tracks>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/ON/S Tracks\*.trk>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
EDIT FILESLIST.TXT
DEL FILESLIST.TXT /P
@ECHO.
PAUSE
GOTO TOP

:VERBOSELIST
@ECHO >>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Cars>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/ON/V Cars\*.car>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Drivers>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/ON/V Drivers\*.drv>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Options>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/V GR.ini>>FILESLIST.TXT
DIR/V Options.opt>>FILESLIST.TXT
DIR/V Options.set>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Saved Seasons>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/ON/V Saves\*.gam>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Sound Folders>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/AD/ON/V Sounds>>FILESLIST.TXT
@ECHO.>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
@ECHO Tracks>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
DIR/ON/S/V Tracks\*.trk>>FILESLIST.TXT
@ECHO >>FILESLIST.TXT
EDIT FILESLIST.TXT
DEL FILESLIST.TXT /P
@ECHO.
PAUSE
GOTO TOP

:VIEWSHOT
IF NOT EXIST Screens\Shot0000.bmp GOTO NOSHOT
RUNDLL32 URL.DLL,FileProtocolHandler Screens\Shot0000.bmp
GOTO TOP

:DELETESHOTS
IF NOT EXIST Screens\Shot0000.bmp GOTO NOSHOTS
@ECHO.
DEL Screens\Shot????.bmp /P
@ECHO.
PAUSE
GOTO TOP

:GENERALLY
IF NOT EXIST GeneRally.exe GOTO NOGENERALLY
GeneRally
GOTO TOP

:TRACKEDITOR
IF NOT EXIST TrackEditor.exe GOTO NOTRACKEDITOR
TrackEditor
GOTO TOP

:SORTCARS
IF NOT EXIST Cars\Cars.car GOTO NOCARS
@ECHO ; This file (TEMP.LST) sets the sort order of all of your GeneRally car>>TEMP.LST
@ECHO ; files. By default, all of the car files are sorted alphabetically by>>TEMP.LST
@ECHO ; filename (excluding GeneRally's stock "Cars.car" file). If you wish, you>>TEMP.LST
@ECHO ; can edit this temporary list file at this time to change the order in which>>TEMP.LST
@ECHO ; the car files are sorted.>>TEMP.LST
@ECHO ;>>TEMP.LST
@ECHO ; Note that GeneRally's stock "Cars.car" file will always be sorted as the>>TEMP.LST
@ECHO ; first car file (reguardless of where it is located in this list file).>>TEMP.LST
@ECHO ;>>TEMP.LST
@ECHO ; IMPORTANT NOTE: DO NOT delete any entries or change the actual filenames of>>TEMP.LST
@ECHO ; the car files in this list file, as the cars will be permanently deleted>>TEMP.LST
@ECHO ; from your hard drive! You may edit the sort order, but ensure that you DO>>TEMP.LST
@ECHO ; NOT delete or modify any of the filenames in any way! If you accidently>>TEMP.LST
@ECHO ; delete or modify any of the entries or filenames, simply exit MS-DOS Editor>>TEMP.LST
@ECHO ; WITHOUT saving the TEMP.LST file, and select the "Sort [C]ar Files" option>>TEMP.LST
@ECHO ; again from the main menu.>>TEMP.LST
@ECHO ;>>TEMP.LST
PKZIP TEMP.ZIP -@UNSORTED.LST Cars\*.car
SORT<UNSORTED.LST>SORTED.LST
COPY/B TEMP.LST+SORTED.LST
EDIT TEMP.LST
PKZIP -! -es TEMP.ZIP Cars\Cars.car
PKZIP -! -es TEMP.ZIP @TEMP.LST
DEL Cars\*.car
PKUNZIP TEMP.ZIP Cars
DEL SORTED.LST
DEL TEMP.LST
DEL TEMP.ZIP
DEL UNSORTED.LST
@ECHO.
@ECHO Car files sorted!
@ECHO.
PAUSE
GOTO TOP

:SORTSOUNDS
IF NOT EXIST Sounds\howto.txt GOTO NOSOUNDS
PKZIP -! -es -o -P -r TEMP.ZIP Sounds\*.*
DELTREE /Y Sounds\*.*
PKUNZIP TEMP.ZIP -d -en
DEL TEMP.ZIP
@ECHO.
@ECHO Sound folders sorted!
@ECHO.
PAUSE
GOTO TOP

:EDITINI
IF NOT EXIST GR.ini GOTO NOINI
EDIT GR.ini
@ECHO.
@ECHO If you have made any edits or changes to the GeneRally advanced game options
@ECHO file (GR.ini), remember to back up your files again.
@ECHO.
PAUSE
GOTO TOP

:OPTIONTOY
IF NOT EXIST GROPTTOY.EXE GOTO NOOPTIONTOY
GROPTTOY
@ECHO.
@ECHO If you have made any edits or changes using the GeneRally OptionToy, remember
@ECHO to back up your files again.
@ECHO.
PAUSE
GOTO TOP

:OPTSUTILITY
IF NOT EXIST Options.exe GOTO NOOPTSUTILITY
Options
@ECHO.
@ECHO If you have made any edits or changes using Juan's "GeneRally Options" Utility,
@ECHO remember to back up your files again.
@ECHO.
PAUSE
GOTO TOP

:METRICAL
IF NOT EXIST METRICAL.HTM GOTO NOMETRICAL
RUNDLL32 URL.DLL,FileProtocolHandler METRICAL.HTM
REM "C:\Program Files\Internet Explorer\IEXPLORE.EXE" "C:\GeneRally\METRICAL.HTM"
GOTO TOP

:EXPLORER
EXPLORER /N,/E
GOTO TOP

:HELP
EDIT GRBACKUP.TXT
GOTO TOP

:NOARCHIVE
@ECHO.
@ECHO GRBACKUP.ZIP GENERALLY BACKUP ARCHIVE NOT FOUND, BACKUP YOUR FILES FIRST!
@ECHO.
PAUSE
GOTO TOP

:NOAUTOSAVE
@ECHO.
@ECHO AUTOSAVE.GAM SAVED SEASON NOT FOUND, RUN GENERALLY FIRST!
@ECHO.
PAUSE
GOTO TOP

:NOSHOT
@ECHO.
@ECHO SHOT0000.BMP SCREENSHOT NOT FOUND, RUN GENERALLY FIRST AND PRESS F12!
@ECHO.
PAUSE
GOTO TOP

:NOSHOTS
@ECHO.
@ECHO SCREENSHOTS NOT FOUND, RUN GENERALLY FIRST AND PRESS F12!
@ECHO.
PAUSE
GOTO TOP

:NOGENERALLY
@ECHO.
@ECHO GENERALLY NOT FOUND, READ GRBACKUP.TXT FOR INSTALLATION INSTRUCTIONS FIRST!
@ECHO.
PAUSE
GOTO TOP

:NOTRACKEDITOR
@ECHO.
@ECHO TRACK EDITOR NOT FOUND, READ GRBACKUP.TXT FOR INSTALLATION INSTRUCTIONS FIRST!
@ECHO.
PAUSE
GOTO TOP

:NOCARS
@ECHO.
@ECHO CAR FILES NOT FOUND, READ GRBACKUP.TXT FOR INSTALLATION INSTRUCTIONS FIRST!
@ECHO.
PAUSE
GOTO TOP

:NOSOUNDS
@ECHO.
@ECHO SOUND FOLDERS NOT FOUND, READ GRBACKUP.TXT FOR INSTALLATION INSTRUCTIONS FIRST!
@ECHO.
PAUSE
GOTO TOP

:NOINI
@ECHO.
@ECHO GR.INI FILE NOT FOUND, READ GRBACKUP.TXT FOR INSTALLATION INSTRUCTIONS FIRST!
@ECHO.
PAUSE
GOTO TOP

:NOOPTIONTOY
@ECHO.
@ECHO OPTIONTOY NOT FOUND, INSTALL GENERALLY OPTIONTOY FIRST!
@ECHO.
PAUSE
GOTO TOP

:NOOPTSUTILITY
@ECHO.
@ECHO GENERALLY OPTIONS UTILITY NOT FOUND, INSTALL GENERALLY OPTIONS UTILITY FIRST!
@ECHO.
PAUSE
GOTO TOP

:NOMETRICAL
@ECHO.
@ECHO METRIC CALCULATOR NOT FOUND, INSTALL METRIC CALCULATOR FIRST!
@ECHO.
PAUSE
GOTO TOP

:QUIT
@ECHO >CON
@ECHO.
@ECHO GENTLEMEN, START YOUR ENGINES!
